You cannot select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

35 lines
1.0 KiB
Bash

#!/usr/bin/env bash
readonly REPO={{ repo | quote }};
readonly DEST={{ dest | quote }};
readonly DEST_USER={{ owner | quote }};
readonly DEST_GROUP={{ group | quote }};
readonly PREFIX={{ tag_prefix | quote }};
readonly GPG_FINGERPRINT={{ gpg_fingerprint | quote }};
set -euo pipefail;
cd "$DEST";
if [ ! -d .git ]; then
git clone --recurse-submodules "$REPO" "$DEST";
fi
[ -z "$GPG_FINGERPRINT" ] ||
gpg --quiet --keyserver eu.pool.sks-keyservers.net --recv "$GPG_FINGERPRINT";
git fetch --recurse-submodules --tags > /dev/null;
TAG=$(git tag --list | grep "^$PREFIX" | sort -r | head -n 1);
if [ -z "$GPG_FINGERPRINT" ] || (git verify-tag --raw "$TAG" 2>&1 | grep --fixed-strings " VALIDSIG $GPG_FINGERPRINT ") > /dev/null; then
git reset --hard --recurse-submodules;
git checkout --quiet --recurse-submodules "$TAG";
chown --recursive "$DEST_USER:$DEST_GROUP" .;
if ! sh -c {{ reload_command | default('true') | quote }}; then
echo "Failed during reload" >&2;
exit 2;
fi
else
echo "Invalid or missing signature for $TAG" >&2;
exit 1;
fi